#include <stdio.h>
#define MAXCOL 10
#define MAXROW 20

typedef float MATRICE[ MAXROW][MAXCOL];
float floatsomme(  float  a[][MAXCOL],  int nl, int nc);
int lir_mat( float  a[][MAXCOL], int *nl, int *nc, const int maxrow, const int maxcol);
void aff_mat( float  a[][MAXCOL], const int nl, const int nc);
void main (void) {
  int noml, nomc;
  MATRICE monmat;
  lir_mat(monmat, &noml,&nomc, MAXROW, MAXCOL);
  aff_mat(monmat,noml,nomc);
  printf ("la somme: %7.3f\n", floatsomme(monmat,noml,nomc));
}
float floatsomme(  float  a[][MAXCOL],  int nl, int nc){
  int i,j;
  float s = 0;
  for (i=0; i<nl;i++)
	 for (j=0; j<nc; j++)
		 s+=a[i][j];
  return s;
}
int lit_entier_verifie(const int m, const int n){
 int x,y;
 do {
  printf ("Entrez un nombre entre %d et %d: ",m,n);
  y = scanf("%d",&x);
  if (y==EOF) {
     x = -32000;  // erreur
     break;
  }
  if (y!=1) {  // des symbols invalides
     getchar();
     putchar('\n') ;
  }
 }while (y == 0 || x < m || x > n);
 return x ;
}

/*  cette fonction lit au maximum maxnom lments entiers
	du tableeau a et rend comm rsultat le nombre actuel
	d'lments lus
*/
int lir_mat( float  a[][MAXCOL], int *nl, int *nc, const int maxrow, const int maxcol){
  int i,j;
  *nl = lit_entier_verifie(1,maxrow);
  if (*nl <0) return 0;
  *nc = lit_entier_verifie(1,maxcol);
  if (*nc <0) return 0;
	printf("Tapez %d nombres rels\n",*nl* *nc);
  for (i=0; i<*nl; i++)
	 for (j=0; j<*nc; j++)
	  scanf("%f",&a[i][j]);
  return *nl* *nc;
}

/*  cette fonction affiche lments entiers
	du tableeau a
*/

void aff_mat( float  a[][MAXCOL], const int nl, const int nc){
  int i,j;
  printf("Les %d lments du tableau\n",nl*nc);
  for (i=0; i<nl; i++)  {
	 for (j=0; j<nc; j++)
	  printf("%5.2f, ",a[i][j]);
	 printf ("\n");
  }
}
